#[doc = "Register `PLD_MC_CFG_XORFB` reader"]
pub struct R(crate::R<PLD_MC_CFG_XORFB_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<PLD_MC_CFG_XORFB_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::convert::From<crate::R<PLD_MC_CFG_XORFB_SPEC>> for R {
    fn from(reader: crate::R<PLD_MC_CFG_XORFB_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `PLD_MC_CFG_XORFB` writer"]
pub struct W(crate::W<PLD_MC_CFG_XORFB_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<PLD_MC_CFG_XORFB_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl core::convert::From<crate::W<PLD_MC_CFG_XORFB_SPEC>> for W {
    fn from(writer: crate::W<PLD_MC_CFG_XORFB_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "XOR feedback\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
#[repr(u8)]
pub enum PLD0_MC0_XORFB_A {
    #[doc = "0: No description available"]
    DFF = 0,
    #[doc = "1: No description available"]
    CARRY = 1,
    #[doc = "2: No description available"]
    TFF_H = 2,
    #[doc = "3: No description available"]
    TFF_L = 3,
}
impl From<PLD0_MC0_XORFB_A> for u8 {
    #[inline(always)]
    fn from(variant: PLD0_MC0_XORFB_A) -> Self {
        variant as _
    }
}
#[doc = "Field `PLD0_MC0_XORFB` reader - XOR feedback"]
pub struct PLD0_MC0_XORFB_R(crate::FieldReader<u8, PLD0_MC0_XORFB_A>);
impl PLD0_MC0_XORFB_R {
    pub(crate) fn new(bits: u8) -> Self {
        PLD0_MC0_XORFB_R(crate::FieldReader::new(bits))
    }
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> PLD0_MC0_XORFB_A {
        match self.bits {
            0 => PLD0_MC0_XORFB_A::DFF,
            1 => PLD0_MC0_XORFB_A::CARRY,
            2 => PLD0_MC0_XORFB_A::TFF_H,
            3 => PLD0_MC0_XORFB_A::TFF_L,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `DFF`"]
    #[inline(always)]
    pub fn is_dff(&self) -> bool {
        **self == PLD0_MC0_XORFB_A::DFF
    }
    #[doc = "Checks if the value of the field is `CARRY`"]
    #[inline(always)]
    pub fn is_carry(&self) -> bool {
        **self == PLD0_MC0_XORFB_A::CARRY
    }
    #[doc = "Checks if the value of the field is `TFF_H`"]
    #[inline(always)]
    pub fn is_tff_h(&self) -> bool {
        **self == PLD0_MC0_XORFB_A::TFF_H
    }
    #[doc = "Checks if the value of the field is `TFF_L`"]
    #[inline(always)]
    pub fn is_tff_l(&self) -> bool {
        **self == PLD0_MC0_XORFB_A::TFF_L
    }
}
impl core::ops::Deref for PLD0_MC0_XORFB_R {
    type Target = crate::FieldReader<u8, PLD0_MC0_XORFB_A>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `PLD0_MC0_XORFB` writer - XOR feedback"]
pub struct PLD0_MC0_XORFB_W<'a> {
    w: &'a mut W,
}
impl<'a> PLD0_MC0_XORFB_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PLD0_MC0_XORFB_A) -> &'a mut W {
        self.bits(variant.into())
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn dff(self) -> &'a mut W {
        self.variant(PLD0_MC0_XORFB_A::DFF)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn carry(self) -> &'a mut W {
        self.variant(PLD0_MC0_XORFB_A::CARRY)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn tff_h(self) -> &'a mut W {
        self.variant(PLD0_MC0_XORFB_A::TFF_H)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn tff_l(self) -> &'a mut W {
        self.variant(PLD0_MC0_XORFB_A::TFF_L)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x03) | (value as u16 & 0x03);
        self.w
    }
}
#[doc = "XOR feedback\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
#[repr(u8)]
pub enum PLD0_MC1_XORFB_A {
    #[doc = "0: No description available"]
    DFF = 0,
    #[doc = "1: No description available"]
    CARRY = 1,
    #[doc = "2: No description available"]
    TFF_H = 2,
    #[doc = "3: No description available"]
    TFF_L = 3,
}
impl From<PLD0_MC1_XORFB_A> for u8 {
    #[inline(always)]
    fn from(variant: PLD0_MC1_XORFB_A) -> Self {
        variant as _
    }
}
#[doc = "Field `PLD0_MC1_XORFB` reader - XOR feedback"]
pub struct PLD0_MC1_XORFB_R(crate::FieldReader<u8, PLD0_MC1_XORFB_A>);
impl PLD0_MC1_XORFB_R {
    pub(crate) fn new(bits: u8) -> Self {
        PLD0_MC1_XORFB_R(crate::FieldReader::new(bits))
    }
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> PLD0_MC1_XORFB_A {
        match self.bits {
            0 => PLD0_MC1_XORFB_A::DFF,
            1 => PLD0_MC1_XORFB_A::CARRY,
            2 => PLD0_MC1_XORFB_A::TFF_H,
            3 => PLD0_MC1_XORFB_A::TFF_L,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `DFF`"]
    #[inline(always)]
    pub fn is_dff(&self) -> bool {
        **self == PLD0_MC1_XORFB_A::DFF
    }
    #[doc = "Checks if the value of the field is `CARRY`"]
    #[inline(always)]
    pub fn is_carry(&self) -> bool {
        **self == PLD0_MC1_XORFB_A::CARRY
    }
    #[doc = "Checks if the value of the field is `TFF_H`"]
    #[inline(always)]
    pub fn is_tff_h(&self) -> bool {
        **self == PLD0_MC1_XORFB_A::TFF_H
    }
    #[doc = "Checks if the value of the field is `TFF_L`"]
    #[inline(always)]
    pub fn is_tff_l(&self) -> bool {
        **self == PLD0_MC1_XORFB_A::TFF_L
    }
}
impl core::ops::Deref for PLD0_MC1_XORFB_R {
    type Target = crate::FieldReader<u8, PLD0_MC1_XORFB_A>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `PLD0_MC1_XORFB` writer - XOR feedback"]
pub struct PLD0_MC1_XORFB_W<'a> {
    w: &'a mut W,
}
impl<'a> PLD0_MC1_XORFB_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PLD0_MC1_XORFB_A) -> &'a mut W {
        self.bits(variant.into())
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn dff(self) -> &'a mut W {
        self.variant(PLD0_MC1_XORFB_A::DFF)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn carry(self) -> &'a mut W {
        self.variant(PLD0_MC1_XORFB_A::CARRY)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn tff_h(self) -> &'a mut W {
        self.variant(PLD0_MC1_XORFB_A::TFF_H)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn tff_l(self) -> &'a mut W {
        self.variant(PLD0_MC1_XORFB_A::TFF_L)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x03 << 2)) | ((value as u16 & 0x03) << 2);
        self.w
    }
}
#[doc = "XOR feedback\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
#[repr(u8)]
pub enum PLD0_MC2_XORFB_A {
    #[doc = "0: No description available"]
    DFF = 0,
    #[doc = "1: No description available"]
    CARRY = 1,
    #[doc = "2: No description available"]
    TFF_H = 2,
    #[doc = "3: No description available"]
    TFF_L = 3,
}
impl From<PLD0_MC2_XORFB_A> for u8 {
    #[inline(always)]
    fn from(variant: PLD0_MC2_XORFB_A) -> Self {
        variant as _
    }
}
#[doc = "Field `PLD0_MC2_XORFB` reader - XOR feedback"]
pub struct PLD0_MC2_XORFB_R(crate::FieldReader<u8, PLD0_MC2_XORFB_A>);
impl PLD0_MC2_XORFB_R {
    pub(crate) fn new(bits: u8) -> Self {
        PLD0_MC2_XORFB_R(crate::FieldReader::new(bits))
    }
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> PLD0_MC2_XORFB_A {
        match self.bits {
            0 => PLD0_MC2_XORFB_A::DFF,
            1 => PLD0_MC2_XORFB_A::CARRY,
            2 => PLD0_MC2_XORFB_A::TFF_H,
            3 => PLD0_MC2_XORFB_A::TFF_L,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `DFF`"]
    #[inline(always)]
    pub fn is_dff(&self) -> bool {
        **self == PLD0_MC2_XORFB_A::DFF
    }
    #[doc = "Checks if the value of the field is `CARRY`"]
    #[inline(always)]
    pub fn is_carry(&self) -> bool {
        **self == PLD0_MC2_XORFB_A::CARRY
    }
    #[doc = "Checks if the value of the field is `TFF_H`"]
    #[inline(always)]
    pub fn is_tff_h(&self) -> bool {
        **self == PLD0_MC2_XORFB_A::TFF_H
    }
    #[doc = "Checks if the value of the field is `TFF_L`"]
    #[inline(always)]
    pub fn is_tff_l(&self) -> bool {
        **self == PLD0_MC2_XORFB_A::TFF_L
    }
}
impl core::ops::Deref for PLD0_MC2_XORFB_R {
    type Target = crate::FieldReader<u8, PLD0_MC2_XORFB_A>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `PLD0_MC2_XORFB` writer - XOR feedback"]
pub struct PLD0_MC2_XORFB_W<'a> {
    w: &'a mut W,
}
impl<'a> PLD0_MC2_XORFB_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PLD0_MC2_XORFB_A) -> &'a mut W {
        self.bits(variant.into())
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn dff(self) -> &'a mut W {
        self.variant(PLD0_MC2_XORFB_A::DFF)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn carry(self) -> &'a mut W {
        self.variant(PLD0_MC2_XORFB_A::CARRY)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn tff_h(self) -> &'a mut W {
        self.variant(PLD0_MC2_XORFB_A::TFF_H)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn tff_l(self) -> &'a mut W {
        self.variant(PLD0_MC2_XORFB_A::TFF_L)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x03 << 4)) | ((value as u16 & 0x03) << 4);
        self.w
    }
}
#[doc = "XOR feedback\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
#[repr(u8)]
pub enum PLD0_MC3_XORFB_A {
    #[doc = "0: No description available"]
    DFF = 0,
    #[doc = "1: No description available"]
    CARRY = 1,
    #[doc = "2: No description available"]
    TFF_H = 2,
    #[doc = "3: No description available"]
    TFF_L = 3,
}
impl From<PLD0_MC3_XORFB_A> for u8 {
    #[inline(always)]
    fn from(variant: PLD0_MC3_XORFB_A) -> Self {
        variant as _
    }
}
#[doc = "Field `PLD0_MC3_XORFB` reader - XOR feedback"]
pub struct PLD0_MC3_XORFB_R(crate::FieldReader<u8, PLD0_MC3_XORFB_A>);
impl PLD0_MC3_XORFB_R {
    pub(crate) fn new(bits: u8) -> Self {
        PLD0_MC3_XORFB_R(crate::FieldReader::new(bits))
    }
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> PLD0_MC3_XORFB_A {
        match self.bits {
            0 => PLD0_MC3_XORFB_A::DFF,
            1 => PLD0_MC3_XORFB_A::CARRY,
            2 => PLD0_MC3_XORFB_A::TFF_H,
            3 => PLD0_MC3_XORFB_A::TFF_L,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `DFF`"]
    #[inline(always)]
    pub fn is_dff(&self) -> bool {
        **self == PLD0_MC3_XORFB_A::DFF
    }
    #[doc = "Checks if the value of the field is `CARRY`"]
    #[inline(always)]
    pub fn is_carry(&self) -> bool {
        **self == PLD0_MC3_XORFB_A::CARRY
    }
    #[doc = "Checks if the value of the field is `TFF_H`"]
    #[inline(always)]
    pub fn is_tff_h(&self) -> bool {
        **self == PLD0_MC3_XORFB_A::TFF_H
    }
    #[doc = "Checks if the value of the field is `TFF_L`"]
    #[inline(always)]
    pub fn is_tff_l(&self) -> bool {
        **self == PLD0_MC3_XORFB_A::TFF_L
    }
}
impl core::ops::Deref for PLD0_MC3_XORFB_R {
    type Target = crate::FieldReader<u8, PLD0_MC3_XORFB_A>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `PLD0_MC3_XORFB` writer - XOR feedback"]
pub struct PLD0_MC3_XORFB_W<'a> {
    w: &'a mut W,
}
impl<'a> PLD0_MC3_XORFB_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PLD0_MC3_XORFB_A) -> &'a mut W {
        self.bits(variant.into())
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn dff(self) -> &'a mut W {
        self.variant(PLD0_MC3_XORFB_A::DFF)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn carry(self) -> &'a mut W {
        self.variant(PLD0_MC3_XORFB_A::CARRY)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn tff_h(self) -> &'a mut W {
        self.variant(PLD0_MC3_XORFB_A::TFF_H)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn tff_l(self) -> &'a mut W {
        self.variant(PLD0_MC3_XORFB_A::TFF_L)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x03 << 6)) | ((value as u16 & 0x03) << 6);
        self.w
    }
}
#[doc = "XOR feedback\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
#[repr(u8)]
pub enum PLD1_MC0_XORFB_A {
    #[doc = "0: No description available"]
    DFF = 0,
    #[doc = "1: No description available"]
    CARRY = 1,
    #[doc = "2: No description available"]
    TFF_H = 2,
    #[doc = "3: No description available"]
    TFF_L = 3,
}
impl From<PLD1_MC0_XORFB_A> for u8 {
    #[inline(always)]
    fn from(variant: PLD1_MC0_XORFB_A) -> Self {
        variant as _
    }
}
#[doc = "Field `PLD1_MC0_XORFB` reader - XOR feedback"]
pub struct PLD1_MC0_XORFB_R(crate::FieldReader<u8, PLD1_MC0_XORFB_A>);
impl PLD1_MC0_XORFB_R {
    pub(crate) fn new(bits: u8) -> Self {
        PLD1_MC0_XORFB_R(crate::FieldReader::new(bits))
    }
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> PLD1_MC0_XORFB_A {
        match self.bits {
            0 => PLD1_MC0_XORFB_A::DFF,
            1 => PLD1_MC0_XORFB_A::CARRY,
            2 => PLD1_MC0_XORFB_A::TFF_H,
            3 => PLD1_MC0_XORFB_A::TFF_L,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `DFF`"]
    #[inline(always)]
    pub fn is_dff(&self) -> bool {
        **self == PLD1_MC0_XORFB_A::DFF
    }
    #[doc = "Checks if the value of the field is `CARRY`"]
    #[inline(always)]
    pub fn is_carry(&self) -> bool {
        **self == PLD1_MC0_XORFB_A::CARRY
    }
    #[doc = "Checks if the value of the field is `TFF_H`"]
    #[inline(always)]
    pub fn is_tff_h(&self) -> bool {
        **self == PLD1_MC0_XORFB_A::TFF_H
    }
    #[doc = "Checks if the value of the field is `TFF_L`"]
    #[inline(always)]
    pub fn is_tff_l(&self) -> bool {
        **self == PLD1_MC0_XORFB_A::TFF_L
    }
}
impl core::ops::Deref for PLD1_MC0_XORFB_R {
    type Target = crate::FieldReader<u8, PLD1_MC0_XORFB_A>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `PLD1_MC0_XORFB` writer - XOR feedback"]
pub struct PLD1_MC0_XORFB_W<'a> {
    w: &'a mut W,
}
impl<'a> PLD1_MC0_XORFB_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PLD1_MC0_XORFB_A) -> &'a mut W {
        self.bits(variant.into())
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn dff(self) -> &'a mut W {
        self.variant(PLD1_MC0_XORFB_A::DFF)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn carry(self) -> &'a mut W {
        self.variant(PLD1_MC0_XORFB_A::CARRY)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn tff_h(self) -> &'a mut W {
        self.variant(PLD1_MC0_XORFB_A::TFF_H)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn tff_l(self) -> &'a mut W {
        self.variant(PLD1_MC0_XORFB_A::TFF_L)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x03 << 8)) | ((value as u16 & 0x03) << 8);
        self.w
    }
}
#[doc = "XOR feedback\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
#[repr(u8)]
pub enum PLD1_MC1_XORFB_A {
    #[doc = "0: No description available"]
    DFF = 0,
    #[doc = "1: No description available"]
    CARRY = 1,
    #[doc = "2: No description available"]
    TFF_H = 2,
    #[doc = "3: No description available"]
    TFF_L = 3,
}
impl From<PLD1_MC1_XORFB_A> for u8 {
    #[inline(always)]
    fn from(variant: PLD1_MC1_XORFB_A) -> Self {
        variant as _
    }
}
#[doc = "Field `PLD1_MC1_XORFB` reader - XOR feedback"]
pub struct PLD1_MC1_XORFB_R(crate::FieldReader<u8, PLD1_MC1_XORFB_A>);
impl PLD1_MC1_XORFB_R {
    pub(crate) fn new(bits: u8) -> Self {
        PLD1_MC1_XORFB_R(crate::FieldReader::new(bits))
    }
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> PLD1_MC1_XORFB_A {
        match self.bits {
            0 => PLD1_MC1_XORFB_A::DFF,
            1 => PLD1_MC1_XORFB_A::CARRY,
            2 => PLD1_MC1_XORFB_A::TFF_H,
            3 => PLD1_MC1_XORFB_A::TFF_L,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `DFF`"]
    #[inline(always)]
    pub fn is_dff(&self) -> bool {
        **self == PLD1_MC1_XORFB_A::DFF
    }
    #[doc = "Checks if the value of the field is `CARRY`"]
    #[inline(always)]
    pub fn is_carry(&self) -> bool {
        **self == PLD1_MC1_XORFB_A::CARRY
    }
    #[doc = "Checks if the value of the field is `TFF_H`"]
    #[inline(always)]
    pub fn is_tff_h(&self) -> bool {
        **self == PLD1_MC1_XORFB_A::TFF_H
    }
    #[doc = "Checks if the value of the field is `TFF_L`"]
    #[inline(always)]
    pub fn is_tff_l(&self) -> bool {
        **self == PLD1_MC1_XORFB_A::TFF_L
    }
}
impl core::ops::Deref for PLD1_MC1_XORFB_R {
    type Target = crate::FieldReader<u8, PLD1_MC1_XORFB_A>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `PLD1_MC1_XORFB` writer - XOR feedback"]
pub struct PLD1_MC1_XORFB_W<'a> {
    w: &'a mut W,
}
impl<'a> PLD1_MC1_XORFB_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PLD1_MC1_XORFB_A) -> &'a mut W {
        self.bits(variant.into())
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn dff(self) -> &'a mut W {
        self.variant(PLD1_MC1_XORFB_A::DFF)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn carry(self) -> &'a mut W {
        self.variant(PLD1_MC1_XORFB_A::CARRY)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn tff_h(self) -> &'a mut W {
        self.variant(PLD1_MC1_XORFB_A::TFF_H)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn tff_l(self) -> &'a mut W {
        self.variant(PLD1_MC1_XORFB_A::TFF_L)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x03 << 10)) | ((value as u16 & 0x03) << 10);
        self.w
    }
}
#[doc = "XOR feedback\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
#[repr(u8)]
pub enum PLD1_MC2_XORFB_A {
    #[doc = "0: No description available"]
    DFF = 0,
    #[doc = "1: No description available"]
    CARRY = 1,
    #[doc = "2: No description available"]
    TFF_H = 2,
    #[doc = "3: No description available"]
    TFF_L = 3,
}
impl From<PLD1_MC2_XORFB_A> for u8 {
    #[inline(always)]
    fn from(variant: PLD1_MC2_XORFB_A) -> Self {
        variant as _
    }
}
#[doc = "Field `PLD1_MC2_XORFB` reader - XOR feedback"]
pub struct PLD1_MC2_XORFB_R(crate::FieldReader<u8, PLD1_MC2_XORFB_A>);
impl PLD1_MC2_XORFB_R {
    pub(crate) fn new(bits: u8) -> Self {
        PLD1_MC2_XORFB_R(crate::FieldReader::new(bits))
    }
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> PLD1_MC2_XORFB_A {
        match self.bits {
            0 => PLD1_MC2_XORFB_A::DFF,
            1 => PLD1_MC2_XORFB_A::CARRY,
            2 => PLD1_MC2_XORFB_A::TFF_H,
            3 => PLD1_MC2_XORFB_A::TFF_L,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `DFF`"]
    #[inline(always)]
    pub fn is_dff(&self) -> bool {
        **self == PLD1_MC2_XORFB_A::DFF
    }
    #[doc = "Checks if the value of the field is `CARRY`"]
    #[inline(always)]
    pub fn is_carry(&self) -> bool {
        **self == PLD1_MC2_XORFB_A::CARRY
    }
    #[doc = "Checks if the value of the field is `TFF_H`"]
    #[inline(always)]
    pub fn is_tff_h(&self) -> bool {
        **self == PLD1_MC2_XORFB_A::TFF_H
    }
    #[doc = "Checks if the value of the field is `TFF_L`"]
    #[inline(always)]
    pub fn is_tff_l(&self) -> bool {
        **self == PLD1_MC2_XORFB_A::TFF_L
    }
}
impl core::ops::Deref for PLD1_MC2_XORFB_R {
    type Target = crate::FieldReader<u8, PLD1_MC2_XORFB_A>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `PLD1_MC2_XORFB` writer - XOR feedback"]
pub struct PLD1_MC2_XORFB_W<'a> {
    w: &'a mut W,
}
impl<'a> PLD1_MC2_XORFB_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PLD1_MC2_XORFB_A) -> &'a mut W {
        self.bits(variant.into())
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn dff(self) -> &'a mut W {
        self.variant(PLD1_MC2_XORFB_A::DFF)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn carry(self) -> &'a mut W {
        self.variant(PLD1_MC2_XORFB_A::CARRY)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn tff_h(self) -> &'a mut W {
        self.variant(PLD1_MC2_XORFB_A::TFF_H)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn tff_l(self) -> &'a mut W {
        self.variant(PLD1_MC2_XORFB_A::TFF_L)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x03 << 12)) | ((value as u16 & 0x03) << 12);
        self.w
    }
}
#[doc = "XOR feedback\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
#[repr(u8)]
pub enum PLD1_MC3_XORFB_A {
    #[doc = "0: No description available"]
    DFF = 0,
    #[doc = "1: No description available"]
    CARRY = 1,
    #[doc = "2: No description available"]
    TFF_H = 2,
    #[doc = "3: No description available"]
    TFF_L = 3,
}
impl From<PLD1_MC3_XORFB_A> for u8 {
    #[inline(always)]
    fn from(variant: PLD1_MC3_XORFB_A) -> Self {
        variant as _
    }
}
#[doc = "Field `PLD1_MC3_XORFB` reader - XOR feedback"]
pub struct PLD1_MC3_XORFB_R(crate::FieldReader<u8, PLD1_MC3_XORFB_A>);
impl PLD1_MC3_XORFB_R {
    pub(crate) fn new(bits: u8) -> Self {
        PLD1_MC3_XORFB_R(crate::FieldReader::new(bits))
    }
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> PLD1_MC3_XORFB_A {
        match self.bits {
            0 => PLD1_MC3_XORFB_A::DFF,
            1 => PLD1_MC3_XORFB_A::CARRY,
            2 => PLD1_MC3_XORFB_A::TFF_H,
            3 => PLD1_MC3_XORFB_A::TFF_L,
            _ => unreachable!(),
        }
    }
    #[doc = "Checks if the value of the field is `DFF`"]
    #[inline(always)]
    pub fn is_dff(&self) -> bool {
        **self == PLD1_MC3_XORFB_A::DFF
    }
    #[doc = "Checks if the value of the field is `CARRY`"]
    #[inline(always)]
    pub fn is_carry(&self) -> bool {
        **self == PLD1_MC3_XORFB_A::CARRY
    }
    #[doc = "Checks if the value of the field is `TFF_H`"]
    #[inline(always)]
    pub fn is_tff_h(&self) -> bool {
        **self == PLD1_MC3_XORFB_A::TFF_H
    }
    #[doc = "Checks if the value of the field is `TFF_L`"]
    #[inline(always)]
    pub fn is_tff_l(&self) -> bool {
        **self == PLD1_MC3_XORFB_A::TFF_L
    }
}
impl core::ops::Deref for PLD1_MC3_XORFB_R {
    type Target = crate::FieldReader<u8, PLD1_MC3_XORFB_A>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `PLD1_MC3_XORFB` writer - XOR feedback"]
pub struct PLD1_MC3_XORFB_W<'a> {
    w: &'a mut W,
}
impl<'a> PLD1_MC3_XORFB_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PLD1_MC3_XORFB_A) -> &'a mut W {
        self.bits(variant.into())
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn dff(self) -> &'a mut W {
        self.variant(PLD1_MC3_XORFB_A::DFF)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn carry(self) -> &'a mut W {
        self.variant(PLD1_MC3_XORFB_A::CARRY)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn tff_h(self) -> &'a mut W {
        self.variant(PLD1_MC3_XORFB_A::TFF_H)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn tff_l(self) -> &'a mut W {
        self.variant(PLD1_MC3_XORFB_A::TFF_L)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x03 << 14)) | ((value as u16 & 0x03) << 14);
        self.w
    }
}
impl R {
    #[doc = "Bits 0:1 - XOR feedback"]
    #[inline(always)]
    pub fn pld0_mc0_xorfb(&self) -> PLD0_MC0_XORFB_R {
        PLD0_MC0_XORFB_R::new((self.bits & 0x03) as u8)
    }
    #[doc = "Bits 2:3 - XOR feedback"]
    #[inline(always)]
    pub fn pld0_mc1_xorfb(&self) -> PLD0_MC1_XORFB_R {
        PLD0_MC1_XORFB_R::new(((self.bits >> 2) & 0x03) as u8)
    }
    #[doc = "Bits 4:5 - XOR feedback"]
    #[inline(always)]
    pub fn pld0_mc2_xorfb(&self) -> PLD0_MC2_XORFB_R {
        PLD0_MC2_XORFB_R::new(((self.bits >> 4) & 0x03) as u8)
    }
    #[doc = "Bits 6:7 - XOR feedback"]
    #[inline(always)]
    pub fn pld0_mc3_xorfb(&self) -> PLD0_MC3_XORFB_R {
        PLD0_MC3_XORFB_R::new(((self.bits >> 6) & 0x03) as u8)
    }
    #[doc = "Bits 8:9 - XOR feedback"]
    #[inline(always)]
    pub fn pld1_mc0_xorfb(&self) -> PLD1_MC0_XORFB_R {
        PLD1_MC0_XORFB_R::new(((self.bits >> 8) & 0x03) as u8)
    }
    #[doc = "Bits 10:11 - XOR feedback"]
    #[inline(always)]
    pub fn pld1_mc1_xorfb(&self) -> PLD1_MC1_XORFB_R {
        PLD1_MC1_XORFB_R::new(((self.bits >> 10) & 0x03) as u8)
    }
    #[doc = "Bits 12:13 - XOR feedback"]
    #[inline(always)]
    pub fn pld1_mc2_xorfb(&self) -> PLD1_MC2_XORFB_R {
        PLD1_MC2_XORFB_R::new(((self.bits >> 12) & 0x03) as u8)
    }
    #[doc = "Bits 14:15 - XOR feedback"]
    #[inline(always)]
    pub fn pld1_mc3_xorfb(&self) -> PLD1_MC3_XORFB_R {
        PLD1_MC3_XORFB_R::new(((self.bits >> 14) & 0x03) as u8)
    }
}
impl W {
    #[doc = "Bits 0:1 - XOR feedback"]
    #[inline(always)]
    pub fn pld0_mc0_xorfb(&mut self) -> PLD0_MC0_XORFB_W {
        PLD0_MC0_XORFB_W { w: self }
    }
    #[doc = "Bits 2:3 - XOR feedback"]
    #[inline(always)]
    pub fn pld0_mc1_xorfb(&mut self) -> PLD0_MC1_XORFB_W {
        PLD0_MC1_XORFB_W { w: self }
    }
    #[doc = "Bits 4:5 - XOR feedback"]
    #[inline(always)]
    pub fn pld0_mc2_xorfb(&mut self) -> PLD0_MC2_XORFB_W {
        PLD0_MC2_XORFB_W { w: self }
    }
    #[doc = "Bits 6:7 - XOR feedback"]
    #[inline(always)]
    pub fn pld0_mc3_xorfb(&mut self) -> PLD0_MC3_XORFB_W {
        PLD0_MC3_XORFB_W { w: self }
    }
    #[doc = "Bits 8:9 - XOR feedback"]
    #[inline(always)]
    pub fn pld1_mc0_xorfb(&mut self) -> PLD1_MC0_XORFB_W {
        PLD1_MC0_XORFB_W { w: self }
    }
    #[doc = "Bits 10:11 - XOR feedback"]
    #[inline(always)]
    pub fn pld1_mc1_xorfb(&mut self) -> PLD1_MC1_XORFB_W {
        PLD1_MC1_XORFB_W { w: self }
    }
    #[doc = "Bits 12:13 - XOR feedback"]
    #[inline(always)]
    pub fn pld1_mc2_xorfb(&mut self) -> PLD1_MC2_XORFB_W {
        PLD1_MC2_XORFB_W { w: self }
    }
    #[doc = "Bits 14:15 - XOR feedback"]
    #[inline(always)]
    pub fn pld1_mc3_xorfb(&mut self) -> PLD1_MC3_XORFB_W {
        PLD1_MC3_XORFB_W { w: self }
    }
    #[doc = "Writes raw bits to the register."]
    pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "PLD Macro cell XOR feedback\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [pld_mc_cfg_xorfb](index.html) module"]
pub struct PLD_MC_CFG_XORFB_SPEC;
impl crate::RegisterSpec for PLD_MC_CFG_XORFB_SPEC {
    type Ux = u16;
}
#[doc = "`read()` method returns [pld_mc_cfg_xorfb::R](R) reader structure"]
impl crate::Readable for PLD_MC_CFG_XORFB_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [pld_mc_cfg_xorfb::W](W) writer structure"]
impl crate::Writable for PLD_MC_CFG_XORFB_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets PLD_MC_CFG_XORFB to value 0"]
impl crate::Resettable for PLD_MC_CFG_XORFB_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
